#include <stdlib.h>
#include <math.h>
#include "gluw.h"
#include "vector.h"
#include "obj.h"
#include "hair.h"

int gluw_keyboard(int key , int x , int y)
{
  switch( key ){
  case 'r' :
    view3d.v.x=0.0   ;  view3d.v.y=0.0   ;  view3d.v.z=5.0   ;
    view3d.c.x=0.0   ;  view3d.c.y=0.0   ;  view3d.c.z=0.0   ;
    view3d.u.x=0.0   ;  view3d.u.y=1.0   ;  view3d.u.z=0.0   ;
    view3d.r.x=0.0   ;  view3d.r.y=0.0   ;  view3d.r.z=0.0   ;
    view3d.p.x=0.0   ;  view3d.p.y=0.0   ;  view3d.p.z=0.0   ;
    view3d.scale=1.0 ;
    view3d.cur.x=0.0 ;  view3d.cur.y=0.0 ;  view3d.cur.z=0.0 ;
    view3d.sta.x=0.0 ;  view3d.sta.y=0.0 ;  view3d.sta.z=0.0 ;
    view3d.HGno.n =-1 ;
    setdraw_HR( &view3d, head_obj ) ;
    //glutPostRedisplay();
    break ;
  case 's' :
    hideHGP = (hideHGP+1)%2 ;
    //glutPostRedisplay();
    break ;
  case 'S' :
    hideHG = (hideHG+1)%2 ;
    //glutPostRedisplay();
    break ;
  case 'h' :
    hideHead   = (hideHead+1)%2 ;
    //glutPostRedisplay();
    break ;
  case 'H' :
    hideHeadP  = (hideHeadP+1)%2 ;
    //glutPostRedisplay();
    break ;
  case ' ' :
    if(        edit_mode==0 ){
      selectall_HG( &view3d, HGL, 2 ) ;
    } else if( edit_mode==1 ){
      selectall_HR( &view3d, head_obj, 2 ) ;
    }
    //glutPostRedisplay();
    break ;
  case 'a' :
    if(        edit_mode==0 ){
      selectall_HG( &view3d, HGL, 1 ) ;
    } else if( edit_mode==1 ){
      selectall_HR( &view3d, head_obj, 1 ) ;
    }
    //glutPostRedisplay();
    break ;
  case 'A' :
    if(        edit_mode==0 ){
      selectgid_HG( &view3d, HGL, edit_gid ) ;
    } else if( edit_mode==1 ){
    }
    //glutPostRedisplay();
    break ;
  case '1' :
    edit_gid=0 ;
    //glutPostRedisplay();
    break ;
  case '!' :
    view3d.gp[0].hide = (view3d.gp[0].hide+1)%2 ;
    //glutPostRedisplay();
    break ;
  case '2' :
    edit_gid=1 ;
    //glutPostRedisplay();
    break ;
  case '"' :
    view3d.gp[1].hide = (view3d.gp[1].hide+1)%2 ;
    //glutPostRedisplay();
    break ;
  case '3' :
    edit_gid=2 ;
    //glutPostRedisplay();
    break ;
  case '#' :
    view3d.gp[2].hide = (view3d.gp[2].hide+1)%2 ;
    //glutPostRedisplay();
    break ;
  case '4' :
    edit_gid=3 ;
    //glutPostRedisplay();
    break ;
  case '$' :
    view3d.gp[3].hide = (view3d.gp[3].hide+1)%2 ;
    //glutPostRedisplay();
    break ;
  case 'm' :
    edit_mode=(edit_mode+1)%2 ;
    //glutPostRedisplay();
    break ;
  case 'n' :
    sync_mode=(sync_mode+1)%2 ;
    //glutPostRedisplay();
    break ;
  case 127 : /* DEL */
    if(        edit_mode==0 ){
      del_HG( HGL ) ;
      clr_HS( &view3d ) ;
    } else if( edit_mode==1 ){
    }
    //glutPostRedisplay();
    break ;
  case 'x' :
    if(        edit_mode==0 ){
      clr_HS( &view3d ) ;
    } else if( edit_mode==1 ){
    }
    //glutPostRedisplay();
    break ;
  case 'g' :
    if(        edit_mode==0 ){
    } else if( edit_mode==1 ){
      gen_HG( head_obj, HGL, edit_gid ) ;
    }
    //glutPostRedisplay();
    break ;
  case 'o' :
    write_hair(outputhair,HGL,head_obj) ;
    //printf("output to file %s\n",outputhair) ;
    break ;
  case 'p' :
    write_pov(outputpov,HGL,head_obj) ;
    //printf("output to POVfile %s\n",outputpov) ;
    break ;
  case 'q' :
    exit(0) ;
    break ;
  case 'c' :
    if(        edit_mode==0 ){
      chg_HGgid( head_obj, HGL, edit_gid ) ;
    } else if( edit_mode==1 ){
    }
    //glutPostRedisplay();
    break ;
  case 'y' :
    add_HS( &view3d ) ;
    //glutPostRedisplay();
    break ;
  default :
    return(0) ;
    break ;
  }

  return(1) ;
}
