#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

struct PolyObjData *init_OBJ( int pmax )
{
  int i ;
  struct HG_List *HGL ;

  if( HGmax<0 ) return(NULL) ;

  HGL=(struct HG_List *)malloc( sizeof(struct HG_List) ) ;
  if( HGL==NULL ) return(NULL) ;

  HGL->HG=(struct HairGuide *)malloc( sizeof(struct HairGuide)*HGmax ) ;
  if( HGL->HG==NULL ){
    free(HGL) ;
    return(NULL) ;
  }
  
  HGL->max=HGmax ;
  HGL->n  =0 ;
  for( i=0 ; i<HGL->n ; i++ ){
    HGL->HG[i].type=0 ;
    HGL->HG[i].pnum=0 ;
    HGL->HG[i].nknot=0 ;
    HGL->HG[i].sel=0 ;
    HGL->HG[i].gid=0 ;
    HGL->HG[i].plist=NULL ;
    HGL->HG[i].knots=NULL ;
  }

  return(HGL) ;
}
  
