#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <GL/glut.h>
#include <math.h>
#include "get_token.h"
#include "vector.h"
#include "obj.h"

#define STR_LINE_MAX    65536

int add_HG(struct HairGuide *srcHG, struct HG_List *HGL ) ;

int read_HG(char *fname, struct HG_List *HGL)
{
  FILE   *fp ;
  struct TOKEN_STRUCT tk ;
  int    i ;
  int    bznum=0 ;

  char strline[STR_LINE_MAX] ;
  struct HairGuide HG ;

  fp=fopen(fname,"rb") ;
  if( fp==NULL ) return(-1) ;

  for( i=0 ; i<HGL->n ; i++ ){ /** initialize bezier list **/
    HGL->HG[i].pnum =0 ;
  }
  
  while( -1 ){
    if( fgets( strline , (STR_LINE_MAX-1) , fp )==NULL ) break ;
    get_token( strline , &tk ) ;
    
    if( tk.num>=(1+3*4) && strcmp(tk.pt[0],"bezier")==0 ){
      HG.pnum =((tk.num-1)/3)*3 ; /** _vf(x,y,z=3)Ɋۂ߂ **/
      HG.nknot=8 ;
      
      for( i=0 ; i<HG.nknot ; i++ ){
	if( i<HG.nknot/2 ){
	  HG.knots[i]=0.0 ;
	}else{
	  HG.knots[i]=1.0 ;
	}
      }
      for( i=0 ; i<HG.pnum ; i++ ){
	HG.plist[i]=atof(tk.pt[i+1]) ;
      }
      if( add_HG(&HG,HGL)<0 ){
	fclose(fp) ;
	return(bznum) ;
      }else{
	free(HG.plist) ;
	free(HG.knots) ;
      }
      bznum++ ;
    }
  }

  fclose(fp) ;

  return( bznum ) ;
}

  
