/**************************************/
/* $B#3<!85%Y%/%H%k7?(B/$BD:E@7?(B            */
/**************************************/
struct Vec3D{
  double x ;
  double y ;
  double z ;
} ;

int    RotateVec( struct Vec3D *pos, double angle, struct Vec3D *vec ) ;
int    RotateVecRad( struct Vec3D *pos, double angle, struct Vec3D *vec ) ;
double NormalizeVec(struct Vec3D *va, struct Vec3D *ns) ;
double LengthVec(struct Vec3D *va) ;
void   AddVec(struct Vec3D *va, struct Vec3D *vb, struct Vec3D *vs) ;
void   SubVec(struct Vec3D *va, struct Vec3D *vb, struct Vec3D *vs) ;
void   InvVec(struct Vec3D *va, struct Vec3D *vs) ;
void   ScaleVec(struct Vec3D *va, double s, struct Vec3D *vs ) ;
double DotProduct(struct Vec3D *va, struct Vec3D *vb) ;
void   CrossProduct(struct Vec3D *va, struct Vec3D *vb, struct Vec3D *vs) ;

#define dec2rad(t) (t*M_PI/180.0)
#define rad2dec(t) (t*180.0/M_PI)
