#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include "gluw.h"
#include "vector.h"
#include "obj.h"
#include "hair.h"
#include "resource.h"

int MyOpen(HWND);

int win_command(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
  switch (LOWORD(wp)) {
  case IDM_FOPEN:
    MyOpen(hWnd) ;
    break ;
  case IDM_END:
    SendMessage(hWnd, WM_CLOSE, 0, 0);
    break;
  }
  return(0) ;
}


int MyOpen(HWND hEdit)
{
  char szFile[MAX_PATH];
  char szFileTitle[MAX_PATH];
  OPENFILENAME ofn;
  
  memset(szFile, 0, MAX_PATH) ;
  memset(szFileTitle, 0, MAX_PATH) ;
  memset(&ofn, 0, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = hEdit;
  ofn.lpstrFilter = "text(*.txt)\0*.txt\0All files(*.*)\0*.*\0\0";
  ofn.lpstrFile = szFile;
  ofn.lpstrFileTitle = szFileTitle;
  ofn.nMaxFile = MAX_PATH;
  ofn.nMaxFileTitle = MAX_PATH;
  ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
  ofn.lpstrDefExt = "txt";
  ofn.lpstrTitle = "Lł킩t@CI[v";
  
  if(GetOpenFileName(&ofn) == 0)
    return -1;

  printf("%s\n",szFile) ;
  //  obj_list[0]=read_3ds(szFile) ;
  
  return 0;
}

