#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <GL/glut.h>
#include <math.h>
#include "get_token.h"
#include "vector.h"
#include "obj.h"

#define STR_LINE_MAX    65536

int write_hair(char *fname, struct HG_List *HGL, struct PolyObjData *obj)
{
  FILE   *fp ;
  int    i,j ;
  
  fp=fopen(fname,"wb") ;
  if( fp==NULL ) return(-1) ;

  fprintf(fp,"PN %d\n",obj->pnum) ;
  fprintf(fp,"FN %d\n",obj->fnum) ;
  for( i=0 ; i<obj->pnum ; i++ ){
    fprintf(fp,"P %d %f %f %f\n", i, obj->plist[i].x, obj->plist[i].y, obj->plist[i].z) ;
  }
  for( i=0 ; i<obj->fnum ; i++ ){
    fprintf(fp,"F %d %d %d %d\n", i, obj->flist[i].p0, obj->flist[i].p1, obj->flist[i].p2) ;
  }
  for( i=0 ; i<HGL->n ; i++ ){
    fprintf(fp,"HG %d %d %d %d",
	    HGL->HG[i].type,
	    HGL->HG[i].gid,
	    HGL->HG[i].pid,
	    HGL->HG[i].pnum/3) ;
    for( j=0 ; j<HGL->HG[i].pnum ; j++ ){
      fprintf(fp," %f", HGL->HG[i].plist[j]) ;
    }
    fprintf(fp,"\n") ;
  }

  fclose(fp) ;

  return( 0 ) ;
}

  
